poj2182(线段树计算元素位置)

来源:互联网 发布:java class 命名规范 编辑:程序博客网 时间:2024/05/17 03:39

http://poj.org/problem?id=2182

Lost Cows
Time Limit: 1000MSMemory Limit: 65536KTotal Submissions: 7497Accepted: 4785

Description

N (2 <= N<= 8,000) cows have unique brands in the range 1..N.In a spectacular display of poor judgment, they visited theneighborhood 'watering hole' and drank a few too many beers beforedinner. When it was time to line up for their evening meal, theydid not line up in the required ascending numerical order of theirbrands.

Regrettably, FJ does not have a way to sort them. Furthermore, he'snot very good at observing problems. Instead of writing down eachcow's brand, he determined a rather silly statistic: For each cowin line, he knows the number of cows that precede that cow in linethat do, in fact, have smaller brands than that cow.

Given this data, tell FJ the exact ordering of thecows.

Input

* Line 1: A single integer,N

* Lines 2..N: These N-1 lines describe the number of cows thatprecede a given cow in line and have brands smaller than that cow.Of course, no cows precede the first cow in line, so she is notlisted. Line 2 of the input describes the number of preceding cowswhose brands are smaller than the cow in slot #2; line 3 describesthe number of preceding cows whose brands are smaller than the cowin slot #3; and so on.

Output

* Lines 1..N: Each of the Nlines of output tells the brand of a cow in line. Line #1 of theoutput tells the brand of the first cow in line; line 2 tells thebrand of the second cow; and so on.

Sample Input

51210

Sample Output

24531

Source

USACO 2003 U S Open Orange
意:FJ有n头牛,编号为1~n,它们并没有按照编号的顺序排好队列。现在,FJ只知道每一个牛前面有多少只牛的编号比它大。问你能不能判断出所有牛的编号。

思路:线段树。关键:每次最后一只牛的编号是可以确定的,即为a[i]+1,将其编号从所有牛中删除,则倒数第二只牛的编号又可以确定为a[i]+1,依此类推

解题思路:对于一个给定序列,从后面往前面看是前面有几个数字是比他小的,
0代表前面没有数字比他小,所以肯定是1,把1去掉。
1代表剩下的数中他排在第2位,剩下2,3,4,5,所以是3,
2代表剩下的数中他排在第3位,剩下2,4,5,所以是5,
1代表剩下的数中他排在第2位,剩下2,4,所以是4 ,剩下了一个2。
搜索排在第n位的数是几时可用线段树实现,对于一个线段树中的所代表的线段[a,b],结点中的数值纪录[a,b]中还有多少人没有被去掉,记为len,所以对于一个在剩余数字队列中排在第n位,看这个人是在一个结点的左子树中还是右子树中,
判断的依据是用左子树了的r和n比较,
如果r>n说明在左子树形成的队列中有足够的数字使他排在第n位,于是递归找左子树。
如果r <n说明在左子树形成的队列中没有足够的数字使他排在第n位,所以他在右子树的第n-r位
于是递归在右子树中找;
当然每找到一个数字,要将所有的祖先结点信息改变,即len--;

#include
#include
#include
using namespace std;
#define MAXN 50001
struct point
{
   int left;
   int right;
   int rest;
}seg[3*MAXN];
int range[MAXN];
int ans[MAXN];
int n;
void build(intnum,intleft,int right)
{
   seg[num].left=left;
   seg[num].right=right;
   seg[num].rest=right-left+1;
   if(seg[num].left==seg[num].right)
   {
       return;
   }
   intmid=(left+right)/2;
   build(2*num,left,mid);
   build(2*num+1,mid+1,right);
}
int query(intnum,int n)
{
   seg[num].rest--;
   if(seg[num].left==seg[num].right)
   {
       returnseg[num].left;
   }
   elseif(seg[num*2].rest>=n)
   {
       returnquery(num*2,n);
   }
   else
   {
       returnquery(num*2+1,n-seg[num*2].rest);
   }
}
int main()
{
   int i;
   scanf("%d",&n);
   for(i=2;i<=n;i++)
   {
       scanf("%d",&range[i]);
   }
       range[1]=0;
       build(1,1,n);
       for(i=n;i>=1;i--)
       {
           ans[i]=query(1,range[i]+1);
       }
       for(i=1;i<=n;i++)
       {
           printf("%d\n",ans[i]);
       }
   return 0;
}